% update D based on either gradient descent, or mini-batch gradient descent
% obj: L = ||DX-Y||_{F}
% partial derivative: \frac{\partial L}{\partial D} = (D*X-Y)*X'
% X: sparse code, each column is a sparse code
% Y: features, each column is a feature
% D: dictionary
% taud: learning rate
function D = ProjC2(D,X,Y,taud)
if size(Y,2) < 10000
D = D - taud*(D*X-Y)*X';
else
    S = size(Y,2);
    r = randperm(S);
    for i = 1:floor(S/1000)
    Y1 = Y(:,r(i:i+1000));
    X1 = X(:,r(i:i+1000));
    D = D - taud*(D*X1-Y1)*X1';
    end
end
